//-----------------------------------------------------------------|
//Vypocet integralu numerickou metodou - pomoci Simpsonova pravida |
//-----------------------------------------------------------------|


#include <cmath>  //pri zadavani matemeticke funcke bude uzivatel pravdepodobne potrebovat tuto knihovnu
#include <iostream>

using std::cout;
using std::cin;
using std::endl;

double f(double x)
{

	double function = x*x*x;    //vlastni matematicka funkce

	return function;
}

double analytic(double x)
{


	double integral = 0.25*x*x*x*x; //zde muze uzivatel zadat analyticky tvar integralu z integrovane matematicke funkce, pokud ji zna
	
	return integral;	
}


double simpson(double n, double a, double b)
{

	double h = (b - a)/n;

	double S = f(a) + 4.0 * f(a+h) +f(b);

	for(int i = 2; i != n; i += 2)
	{
		S = S + ( 2 * f(a + i*h) );
		S = S + ( 4 * f(a + (i+1)*h) );
	}

	return (1.0/3.0)*h*S;

}

int main()
{
	double a, b, n;

//pokud uzivatel nechce zadavat hodnoty mezi a pocet delicich intervalu až po spuštění programu, musi odkomentovat a upravit nasledujici tri radky, a zakomentovat dalsich sest

/*	n = 10.0;  // zde volime pocet intervalu, na ktere bude funce pri integraci delena. !!!Pozor: n musi byt SUDE! a celociselne!!!
	a = -1.0;  //
	b = 1.0; // promene predstavuj pocatek a konec intervalu  <a,b>, pres ktery bude funkce integrovana
*/
	cout << "Dolni mez a = ";
	cin >> a;
	cout << "Horni mez b = ";
	cin >> b;
	cout << "Pocet deleni (celosciselne, sude cislo)  n = ";
	cin >> n;



	double result = simpson(n,a,b);
	cout << "Simpsonova metoda:  " << result << endl;

	//pokud uzivatel nezna analyticky tvar integralu z jeho funkce, nebo ho z nejakeho duvodu nechce zapsat do funkce analytic, musi zakomentovat nasledujici dva radky a mel by zakomentovat i celou funkci analytic
	double analyticresult = analytic(b) - analytic(a);
	cout << "Dosazeni do analytickeho tvaru integralu: "<< analyticresult << endl;


	return 0;
}
